# std::ctype< char > Class Template Reference

The ctype<char> specialization. More...

`#include <locale_facets.h>`

Inheritance diagram for std::ctype< char >:

[legend]
Collaboration diagram for std::ctype< char >:

[legend]
List of all members.

## Public Types

typedef char | char_type
| Typedef for the template parameter char.

## Public Member Functions

| ctype (const mask *__table=0, bool __del=false, size_t __refs=0)
| Constructor performs initialization.
| ctype (c_locale cloc, const mask *__table=0, bool __del=false, size_t __refs=0)
| Constructor performs static initialization.
bool | is (mask __m, char c) const
| Test char classification.
const char * | is (const char *__lo, const char *__hi, mask *__vec) const
| Return a mask array.
const char * | scan_is (mask __m, const char *__lo, const char *__hi) const
| Find char matching a mask.
const char * | scan_not (mask __m, const char *__lo, const char *__hi) const
| Find char not matching a mask.
char_type | toupper (char_type c) const
| Convert to uppercase.
const char_type * | toupper (char_type *__lo, const char_type *__hi) const
| Convert array to uppercase.
char_type | tolower (char_type c) const
| Convert to lowercase.
const char_type * | tolower (char_type *__lo, const char_type *__hi) const
| Convert array to lowercase.
char_type | widen (char c) const
| Widen char.
const char * | widen (const char *__lo, const char *__hi, char_type *__to) const
| Widen char array.
char | narrow (char_type c, char __dfault) const
| Narrow char.
const char_type * | narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
| Narrow char array.

## Static Public Attributes

locale::id | id
| The facet id for ctype<char>.
const size_t | table_size
| The size of the mask table. It is SCHARMAX + 1.

## Protected Member Functions

const mask * | table () const throw ()
| Returns a pointer to the mask table provided to the constructor, or the default from classic_table() if none was provided.
virtual | ~ctype ()
| Destructor.
virtual char_type | do_toupper (char_type) const
| Convert to uppercase.
virtual const char_type * | do_toupper (char_type *__lo, const char_type *__hi) const
| Convert array to uppercase.
virtual char_type | do_tolower (char_type) const
| Convert to lowercase.
virtual const char_type * | do_tolower (char_type *__lo, const char_type *__hi) const
| Convert array to lowercase.
virtual char_type | do_widen (char c) const
| Widen char.
virtual const char * | do_widen (const char *__lo, const char *__hi, char_type *__dest) const
| Widen char array.
virtual char | do_narrow (char_type c, char) const
| Narrow char.
virtual const char_type * | do_narrow (const char_type *__lo, const char_type *__hi, char, char *__dest) const
| Narrow char array to char array.

## Static Protected Member Functions

const mask * | classic_table () throw ()
| Returns a pointer to the C locale mask table.

## Detailed Description

### template<>
class std::ctype< char >

The ctype<char> specialization.

This class defines classification and conversion functions for the char type. It gets used by char streams for many I/O operations. The char specialization provides a number of optimizations as well.

Definition at line 675 of file locale_facets.h.

## Member Typedef Documentation

typedef char std::ctype< char >::char_type

| Typedef for the template parameter char. Definition at line 680 of file locale_facets.h.

## Constructor & Destructor Documentation

std::ctype< char >::~ctype | ( |  | ) | `[protected, virtual]`

| Destructor. This function deletes table() if del was true in the constructor. Definition at line 80 of file ctype.cc.

## Member Function Documentation

const mask* std::ctype< char >::classic_table | ( |  | ) | throw ()`[static, protected]`

| Returns a pointer to the C locale mask table.

std::ctype< char >::ctype | ( | c_locale | cloc,
|  | const mask * | __table = `0`,
|  | bool | __del = `false`,
|  | size_t | __refs = `0`
| ) | `[explicit]`

Constructor performs static initialization.

This constructor is used to construct the initial C locale facet.

Parameters:

  | cloc | Handle to C locale data.
  | table | If non-zero, table is used as the per-char mask.
  | del | If true, passes ownership of table to this facet.
  | refs | Passed to the base facet class.

std::ctype< char >::ctype | ( | const mask * | __table = `0`,
|  | bool | __del = `false`,
|  | size_t | __refs = `0`
| ) | `[explicit]`

Constructor performs initialization.

This is the constructor provided by the standard.

Parameters:

  | table | If non-zero, table is used as the per-char mask. Else classic_table() is used.
  | del | If true, passes ownership of table to this facet.
  | refs | Passed to the base facet class.

virtual const char_type* std::ctype< char >::do_narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | ,
|  | char * | __dest
| ) | const`[inline, protected, virtual]`

Narrow char array to char array.

This virtual function converts each char in the range [lo,hi) to char using the simplest reasonable transformation and writes the results to the destination array. For any char in the input that cannot be converted, dfault is used instead. For an underived ctype<char> facet, the argument will be copied unchanged.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | dfault | Char to use if conversion fails.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 1146 of file locale_facets.h.

virtual char std::ctype< char >::do_narrow | ( | char_type | c,
|  | char |
| ) | const`[inline, protected, virtual]`

Narrow char.

This virtual function converts the char to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. For an underived ctype<char> facet, c will be returned unchanged.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.
  | dfault | Char to return if conversion fails.

Returns:
  The converted char.

Definition at line 1120 of file locale_facets.h.

virtual const char_type* std::ctype< char >::do_tolower | ( | char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[protected, virtual]`

Convert array to lowercase.

This virtual function converts each char in the range [lo,hi) to lowercase if possible. Other chars remain untouched.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:

  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.

Returns:
  hi.

virtual char_type std::ctype< char >::do_tolower | ( | char_type |  | ) | const`[protected, virtual]`

Convert to lowercase.

This virtual function converts the char argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters:

  | c | The char to convert.

Returns:
  The lowercase char if convertible, else c.

virtual const char_type* std::ctype< char >::do_toupper | ( | char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[protected, virtual]`

Convert array to uppercase.

This virtual function converts each char in the range [lo,hi) to uppercase if possible. Other chars remain untouched.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  hi.

virtual char_type std::ctype< char >::do_toupper | ( | char_type |  | ) | const`[protected, virtual]`

Convert to uppercase.

This virtual function converts the char argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters:

  | c | The char to convert.

Returns:
  The uppercase char if convertible, else c.

virtual const char* std::ctype< char >::do_widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __dest
| ) | const`[inline, protected, virtual]`

Widen char array.

This function converts each char in the range [lo,hi) to char using the simplest reasonable transformation. For an underived ctype<char> facet, the argument will be copied unchanged.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 1094 of file locale_facets.h.

virtual char_type std::ctype< char >::do_widen | ( | char | c | ) | const`[inline, protected, virtual]`

Widen char.

This virtual function converts the char to char using the simplest reasonable transformation. For an underived ctype<char> facet, the argument will be returned unchanged.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.

Returns:
  The converted character.

Definition at line 1071 of file locale_facets.h.

const char* std::ctype< char >::is | ( | const char * | __lo,
|  | const char * | __hi,
|  | mask * | __vec
| ) | const`[inline]`

Return a mask array.

This function finds the mask for each char in the range [lo, hi) and successively writes it to vec. vec must have as many elements as the char array.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | vec | Pointer to an array of mask storage.

Returns:
  hi.

bool std::ctype< char >::is | ( | mask | __m,
|  | char | c
| ) | const`[inline]`

Test char classification.

This function compares the mask table[c] to m.

Parameters:

  | c | The char to compare the mask of.
  | m | The mask to compare against.

Returns:
  True if m & table[c] is true, false otherwise.

const char_type* std::ctype< char >::narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to
| ) | const`[inline]`

Narrow char array.

This function converts each char in the input to char using the simplest reasonable transformation and writes the results to the destination array. For any char in the input that cannot be converted, dfault is used instead. For an underived ctype<char> facet, the argument will be copied unchanged.

This function works as if it returns ctype<char>::do_narrow(lo, hi, dfault, to). do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to start of range.
  | hi | Pointer to end of range.
  | dfault | Char to use if conversion fails.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 954 of file locale_facets.h.

char std::ctype< char >::narrow | ( | char_type | c,
|  | char | __dfault
| ) | const`[inline]`

Narrow char.

This function converts the char to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. For an underived ctype<char> facet, c will be returned unchanged.

This function works as if it returns ctype<char>::do_narrow(c). do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.
  | dfault | Char to return if conversion fails.

Returns:
  The converted character.

Definition at line 922 of file locale_facets.h.

const char* std::ctype< char >::scan_is | ( | mask | __m,
|  | const char * | __lo,
|  | const char * | __hi
| ) | const`[inline]`

Find char matching a mask.

This function searches for and returns the first char in [lo,hi) for which is(m,char) is true.

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to a matching char if found, else hi.

const char* std::ctype< char >::scan_not | ( | mask | __m,
|  | const char * | __lo,
|  | const char * | __hi
| ) | const`[inline]`

Find char not matching a mask.

This function searches for and returns a pointer to the first char in [lo,hi) for which is(m,char) is false.

Parameters:

  | m | The mask to compare against.
  | lo | Pointer to start of range.
  | hi | Pointer to end of range.

Returns:
  Pointer to a non-matching char if found, else hi.

const mask* std::ctype< char >::table | ( |  | ) | const throw ()`[inline, protected]`

| Returns a pointer to the mask table provided to the constructor, or the default from classic_table() if none was provided. Definition at line 971 of file locale_facets.h.

const char_type* std::ctype< char >::tolower | ( | char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[inline]`

Convert array to lowercase.

This function converts each char in the range [lo,hi) to lowercase if possible. Other chars remain untouched.

tolower() acts as if it returns ctype<char>:: do_tolower(lo, hi). do_tolower() must always return the same result for the same input.

Parameters:

  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.

Returns:
  hi.

Definition at line 846 of file locale_facets.h.

char_type std::ctype< char >::tolower | ( | char_type | c | ) | const`[inline]`

Convert to lowercase.

This function converts the char argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

tolower() acts as if it returns ctype<char>::do_tolower(c). do_tolower() must always return the same result for the same input.

Parameters:

  | c | The char to convert.

Returns:
  The lowercase char if convertible, else c.

Definition at line 829 of file locale_facets.h.

const char_type* std::ctype< char >::toupper | ( | char_type * | __lo,
|  | const char_type * | __hi
| ) | const`[inline]`

Convert array to uppercase.

This function converts each char in the range [lo,hi) to uppercase if possible. Other chars remain untouched.

toupper() acts as if it returns ctype<char>:: do_toupper(lo, hi). do_toupper() must always return the same result for the same input.

Parameters:

  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.

Returns:
  hi.

Definition at line 813 of file locale_facets.h.

char_type std::ctype< char >::toupper | ( | char_type | c | ) | const`[inline]`

Convert to uppercase.

This function converts the char argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

toupper() acts as if it returns ctype<char>::do_toupper(c). do_toupper() must always return the same result for the same input.

Parameters:

  | c | The char to convert.

Returns:
  The uppercase char if convertible, else c.

Definition at line 796 of file locale_facets.h.

const char* std::ctype< char >::widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __to
| ) | const`[inline]`

Widen char array.

This function converts each char in the input to char using the simplest reasonable transformation. For an underived ctype<char> facet, the argument will be copied unchanged.

This function works as if it returns ctype<char>::do_widen(c). do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | lo | Pointer to first char in range.
  | hi | Pointer to end of range.
  | to | Pointer to the destination array.

Returns:
  hi.

Definition at line 892 of file locale_facets.h.

char_type std::ctype< char >::widen | ( | char | c | ) | const`[inline]`

Widen char.

This function converts the char to char_type using the simplest reasonable transformation. For an underived ctype<char> facet, the argument will be returned unchanged.

This function works as if it returns ctype<char>::do_widen(c). do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters:

  | c | The char to convert.

Returns:
  The converted character.

Definition at line 866 of file locale_facets.h.

## Member Data Documentation

locale::id std::ctype< char >::id `[static]`

| The facet id for ctype<char>. Definition at line 47 of file ctype.cc.

const size_t std::ctype< char >::table_size `[static]`

| The size of the mask table. It is SCHARMAX + 1. Definition at line 78 of file ctype.cc.

The documentation for this class was generated from the following files:

- locale_facets.h
- ctype.cc